from Components.MenuList import MenuList
from Tools.Directories import SCOPE_SKIN_IMAGE, resolveFilename, fileExists
from enigma import RT_HALIGN_LEFT, eListboxPythonMultiContent, gFont, RT_HALIGN_RIGHT, getDesktop
from Tools.LoadPixmap import LoadPixmap
from __init__ import _

def QuickButtonListEntry(key, text, pixmap = None, callevent = None):
	sz_w = getDesktop(0).size().width()
	if sz_w > 1400:
		res = [text]
		if text[0] == '--':
			png = LoadPixmap(resolveFilename(SCOPE_SKIN_IMAGE, '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/pic/op_separator.png'))
			if png is not None:
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHABLEND,
				 0,
				 12,
				 1220,
				 35,
				 png))
		else:
			if callevent is None:
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 45,
				 0,
				 1210,
				 35,
				 0,
				 RT_HALIGN_LEFT,
				 text[0]))
			elif callevent is not None:
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 45,
				 0,
				 700,
				 35,
				 0,
				 RT_HALIGN_LEFT,
				 text[0]))
				if len(callevent) > 70:
					callevent = callevent[:65] + '...'
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 350,
				 0,
				 800,
				 35,
				 1,
				 RT_HALIGN_RIGHT,
				 callevent,
				 32768))
			if pixmap is not None:
				if not callevent:
					pixmap = 'not'
				elif not fileExists('/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/image/key_' + pixmap + '.png'):
					pixmap = 'default'
				path = '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/image/key_' + pixmap + '.png'
			elif (key == 'green' or key == 'red') and callevent == None:
				path = '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/pic/' + key + '.png'
			else:
				path = resolveFilename(SCOPE_SKIN_IMAGE, 'skin_default/buttons/key_' + key + '.png')
			png = LoadPixmap(path)
			if png is not None:
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHABLEND,
				 5,
				 0,
				 35,
				 35,
				 png))
		return res
	else:
		res = [text]
		if text[0] == '--':
			png = LoadPixmap(resolveFilename(SCOPE_SKIN_IMAGE, '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/pic/op_separator.png'))
			if png is not None:
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHABLEND,
				 0,
				 12,
				 780,
				 25,
				 png))
		else:
			if callevent is None:
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 45,
				 0,
				 760,
				 25,
				 0,
				 RT_HALIGN_LEFT,
				 text[0]))
			elif callevent is not None:
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 45,
				 0,
				 300,
				 25,
				 0,
				 RT_HALIGN_LEFT,
				 text[0]))
				if len(callevent) > 70:
					callevent = callevent[:65] + '...'
				res.append((eListboxPythonMultiContent.TYPE_TEXT,
				 350,
				 0,
				 400,
				 25,
				 1,
				 RT_HALIGN_RIGHT,
				 callevent,
				 32768))
			if pixmap is not None:
				if not callevent:
					pixmap = 'not'
				elif not fileExists('/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/image/key_' + pixmap + '.png'):
					pixmap = 'default'
				path = '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/image/key_' + pixmap + '.png'
			elif (key == 'green' or key == 'red') and callevent == None:
				path = '/usr/lib/enigma2/python/Plugins/Extensions/MultiQuickButton/pic/' + key + '.png'
			else:
				path = resolveFilename(SCOPE_SKIN_IMAGE, 'skin_default/buttons/key_' + key + '.png')
			png = LoadPixmap(path)
			if png is not None:
				res.append((eListboxPythonMultiContent.TYPE_PIXMAP_ALPHABLEND,
				 5,
				 0,
				 35,
				 25,
				 png))
		return res

class QuickButtonList(MenuList):

	def __init__(self, list, selection = 0, enableWrapAround = False):
		sz_w = getDesktop(0).size().width()
		if sz_w > 1400:
				MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
				self.l.setFont(0, gFont('Regular', 28))
				self.l.setFont(1, gFont('Regular', 28))
				self.l.setItemHeight(35)
				self.selection = selection
		else:
				MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
				self.l.setFont(0, gFont('Regular', 20))
				self.l.setFont(1, gFont('Regular', 19))
				self.l.setItemHeight(25)
				self.selection = selection

	def postWidgetCreate(self, instance):
		MenuList.postWidgetCreate(self, instance)
		self.moveToIndex(self.selection)

